Loading...
Searching...
No Matches
Opm::LiveOilPvt< Scalar > Class Template Reference

This class represents the Pressure-Volume-Temperature relations of the oil phas with dissolved gas. More...

`#include <LiveOilPvt.hpp>`

## Public Types

using | TabulatedTwoDFunction = UniformXTabulated2DFunction<Scalar>
using | TabulatedOneDFunction = Tabulated1DFunction<Scalar>

## Public Member Functions

void | setNumRegions (size_t numRegions)
void | setVapPars (const Scalar, const Scalar par2)
void | setReferenceDensities (unsigned regionIdx, Scalar rhoRefOil, Scalar rhoRefGas, Scalar)
| Initialize the reference densities of all fluids for a given PVT region.
void | setSaturatedOilGasDissolutionFactor (unsigned regionIdx, const SamplingPoints &samplePoints)
| Initialize the function for the gas dissolution factor .
void | setSaturatedOilFormationVolumeFactor (unsigned regionIdx, const SamplingPoints &samplePoints)
| Initialize the function for the oil formation volume factor.
void | setInverseOilFormationVolumeFactor (unsigned regionIdx, const TabulatedTwoDFunction &invBo)
| Initialize the function for the oil formation volume factor.
void | setOilViscosity (unsigned regionIdx, const TabulatedTwoDFunction &muo)
| Initialize the viscosity of the oil phase.
void | setSaturatedOilViscosity (unsigned regionIdx, const SamplingPoints &samplePoints)
| Initialize the phase viscosity for gas saturated oil.
void | initEnd ()
| Finish initializing the oil phase PVT properties.
unsigned | numRegions () const
| Return the number of PVT regions which are considered by this PVT-object.
template<class Evaluation>
Evaluation | internalEnergy (unsigned, const Evaluation &, const Evaluation &, const Evaluation &) const
| Returns the specific enthalpy [J/kg] of oil given a set of parameters.
Scalar | hVap (unsigned) const
template<class Evaluation>
Evaluation | viscosity (unsigned regionIdx, const Evaluation &, const Evaluation &pressure, const Evaluation &Rs) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | saturatedViscosity (unsigned regionIdx, const Evaluation &, const Evaluation &pressure) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | inverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure, const Evaluation &Rs) const
| Returns the formation volume factor [-] of the fluid phase.
template<class FluidState, class LhsEval = typename FluidState::Scalar>
std::pair< LhsEval, LhsEval > | inverseFormationVolumeFactorAndViscosity (const FluidState &fluidState, unsigned regionIdx)
| Returns the formation volume factor [-] and viscosity [Pa s] of the fluid phase.
template<class Evaluation>
Evaluation | saturatedInverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure) const
| Returns the formation volume factor [-] of the fluid phase.
template<class Evaluation>
Evaluation | saturatedGasDissolutionFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure) const
| Returns the gas dissolution factor [m^3/m^3] of the oil phase.
template<class Evaluation>
Evaluation | saturatedGasDissolutionFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure, const Evaluation &oilSaturation, Evaluation maxOilSaturation) const
| Returns the gas dissolution factor [m^3/m^3] of the oil phase.
template<class Evaluation>
Evaluation | saturationPressure (unsigned regionIdx, const Evaluation &, const Evaluation &Rs) const
| Returns the saturation pressure of the oil phase [Pa] depending on its mass fraction of the gas component.
template<class Evaluation>
Evaluation | diffusionCoefficient (const Evaluation &, const Evaluation &, unsigned) const
Scalar | gasReferenceDensity (unsigned regionIdx) const
Scalar | oilReferenceDensity (unsigned regionIdx) const
const std::vector< TabulatedTwoDFunction > & | inverseOilBTable () const
const std::vector< TabulatedTwoDFunction > & | oilMuTable () const
const std::vector< TabulatedTwoDFunction > & | inverseOilBMuTable () const
const std::vector< TabulatedOneDFunction > & | saturatedOilMuTable () const
const std::vector< TabulatedOneDFunction > & | inverseSaturatedOilBTable () const
const std::vector< TabulatedOneDFunction > & | inverseSaturatedOilBMuTable () const
const std::vector< TabulatedOneDFunction > & | saturatedGasDissolutionFactorTable () const
const std::vector< TabulatedOneDFunction > & | saturationPressure () const
Scalar | vapPar2 () const

## Detailed Description

template<class Scalar>
class Opm::LiveOilPvt< Scalar >

This class represents the Pressure-Volume-Temperature relations of the oil phas with dissolved gas.

## Member Function Documentation

## saturatedGasDissolutionFactor()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::LiveOilPvt< Scalar >::saturatedGasDissolutionFactor | ( | unsigned | regionIdx,
|  | const Evaluation & | ,
|  | const Evaluation & | pressure,
|  | const Evaluation & | oilSaturation,
|  | Evaluation | maxOilSaturation ) const

inline

Returns the gas dissolution factor [m^3/m^3] of the oil phase.

This variant of the method prevents all the oil to be vaporized even if the gas phase is still not saturated. This is physically quite dubious but it corresponds to how the Eclipse 100 simulator handles this. (cf the VAPPARS keyword.)

## saturationPressure()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::LiveOilPvt< Scalar >::saturationPressure | ( | unsigned | regionIdx,
|  | const Evaluation & | ,
|  | const Evaluation & | Rs ) const

inline

Returns the saturation pressure of the oil phase [Pa] depending on its mass fraction of the gas component.

Parameters

  regionIdx | Region index to use
  Rs | The surface volume of gas component dissolved in what will yield one cubic meter of oil at the surface [-]

## setInverseOilFormationVolumeFactor()

template<class Scalar>

void Opm::LiveOilPvt< Scalar >::setInverseOilFormationVolumeFactor | ( | unsigned | regionIdx,
|  | const TabulatedTwoDFunction & | invBo )

inline

Initialize the function for the oil formation volume factor.

The oil formation volume factor is a function of and represents the partial density of the oil component in the oil phase at a given pressure.

This method sets . Note that instead of the mass fraction of the gas component in the oil phase, this function depends on the gas dissolution factor. Also note, that the order of the arguments needs to be and not the other way around.

## setOilViscosity()

template<class Scalar>

void Opm::LiveOilPvt< Scalar >::setOilViscosity | ( | unsigned | regionIdx,
|  | const TabulatedTwoDFunction & | muo )

inline

Initialize the viscosity of the oil phase.

This is a function of ...

## setSaturatedOilFormationVolumeFactor()

template<class Scalar>

void Opm::LiveOilPvt< Scalar >::setSaturatedOilFormationVolumeFactor | ( | unsigned | regionIdx,
|  | const SamplingPoints & | samplePoints )

Initialize the function for the oil formation volume factor.

The oil formation volume factor is a function of and represents the partial density of the oil component in the oil phase at a given pressure. This method only requires the volume factor of gas-saturated oil (which only depends on pressure) while the dependence on the gas mass fraction is guesstimated.

## setSaturatedOilGasDissolutionFactor()

template<class Scalar>

void Opm::LiveOilPvt< Scalar >::setSaturatedOilGasDissolutionFactor | ( | unsigned | regionIdx,
|  | const SamplingPoints & | samplePoints )

inline

Initialize the function for the gas dissolution factor .

Parameters

  regionIdx | Region index to use
  samplePoints | A container of (x,y) values.

## setSaturatedOilViscosity()

template<class Scalar>

void Opm::LiveOilPvt< Scalar >::setSaturatedOilViscosity | ( | unsigned | regionIdx,
|  | const SamplingPoints & | samplePoints )

Initialize the phase viscosity for gas saturated oil.

The oil viscosity is a function of , but this method only requires the viscosity of gas-saturated oil (which only depends on pressure) while there is assumed to be no dependence on the gas mass fraction...

The documentation for this class was generated from the following files:

- opm/material/fluidsystems/blackoilpvt/LiveOilPvt.hpp
- opm/material/fluidsystems/blackoilpvt/LiveOilPvt.cpp